require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__SYS_REFCOUNT_H__)) {
    eval 'sub __SYS_REFCOUNT_H__ () {1;}' unless defined(&__SYS_REFCOUNT_H__);
    require 'sys/limits.ph';
    require 'machine/atomic.ph';
    if(defined(&_KERNEL)) {
	require 'sys/systm.ph';
    } else {
	require 'stdbool.ph';
	eval 'sub KASSERT {
	    my($exp, $msg) = @_;
    	    eval q();
	}' unless defined(&KASSERT);
    }
    eval 'sub refcount_init {
        my($count,$value) = @_;
	    eval q({ *$count = $value; });
    }' unless defined(&refcount_init);
    eval 'sub refcount_acquire {
        my($count) = @_;
	    eval q({  &KASSERT(*$count <  &UINT_MAX, (\\"refcount %p overflowed\\", $count));  &atomic_add_int($count, 1); });
    }' unless defined(&refcount_acquire);
    eval 'sub refcount_acquire_checked {
        my($count) = @_;
	    eval q({ \'u_int\'  &lcount;  &for ( &lcount = *$count;;) {  &if ( &__predict_false( &lcount + 1<  &lcount)) ( &false);  &if ( &__predict_true( &atomic_fcmpset_int($count,  &lcount,  &lcount + 1) == 1)) ( &true); } });
    }' unless defined(&refcount_acquire_checked);
    eval 'sub refcount_releasen {
        my($count,$n) = @_;
	    eval q({ \'u_int\'  &old;  &atomic_thread_fence_rel();  &old =  &atomic_fetchadd_int($count, -$n);  &KASSERT( &old > 0, (\\"refcount %p is zero\\", $count));  &if ( &old > $n) ( &false);  &atomic_thread_fence_acq(); ( &true); });
    }' unless defined(&refcount_releasen);
    eval 'sub refcount_release {
        my($count) = @_;
	    eval q({ ( &refcount_releasen($count, 1)); });
    }' unless defined(&refcount_release);
    eval 'sub refcount_release_if_not_last {
        my($count) = @_;
	    eval q({ \'u_int\'  &old;  &old = *$count;  &for (;;) {  &KASSERT( &old > 0, (\\"refcount %p is zero\\", $count));  &if ( &old == 1) ( &false);  &if ( &atomic_fcmpset_int($count,  &old,  &old - 1)) ( &true); } });
    }' unless defined(&refcount_release_if_not_last);
}
1;
